//****************************************************************************
// @Module        Parallel Ports
// @Filename      IO.c
// @Project       ASC_SSC_IO.dav
//----------------------------------------------------------------------------
// @Controller    Infineon TC1130
//
// @Compiler      Tasking
//
// @Codegenerator 1.4
//
// @Description   This file contains functions that use the IO module.
//
//----------------------------------------------------------------------------
// @Date          2007-05-09 12:05:38
//
//****************************************************************************

// USER CODE BEGIN (IO_General,1)

// USER CODE END



//****************************************************************************
// @Project Includes
//****************************************************************************

#include "MAIN.h"

// USER CODE BEGIN (IO_General,2)

// USER CODE END


//****************************************************************************
// @Macros
//****************************************************************************

// USER CODE BEGIN (IO_General,3)

// USER CODE END


//****************************************************************************
// @Defines
//****************************************************************************

// USER CODE BEGIN (IO_General,4)

// USER CODE END


//****************************************************************************
// @Typedefs
//****************************************************************************

// USER CODE BEGIN (IO_General,5)

// USER CODE END


//****************************************************************************
// @Imported Global Variables
//****************************************************************************

// USER CODE BEGIN (IO_General,6)

// USER CODE END


//****************************************************************************
// @Global Variables
//****************************************************************************

// USER CODE BEGIN (IO_General,7)

// USER CODE END


//****************************************************************************
// @External Prototypes
//****************************************************************************

// USER CODE BEGIN (IO_General,8)

// USER CODE END


//****************************************************************************
// @Prototypes Of Local Functions
//****************************************************************************

// USER CODE BEGIN (IO_General,9)

// USER CODE END


//****************************************************************************
// @Function      void IO_vInit(void) 
//
//----------------------------------------------------------------------------
// @Description   This is the initialization function of the IO function 
//                library. It is assumed that the SFRs used by this library 
//                are in its reset state. 
//                Note:
//                Alternate outputs are set in their own initialization 
//                function.
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          2007-05-09
//
//****************************************************************************

// USER CODE BEGIN (IO_Function,1)

// USER CODE END

void IO_vInit(void)
{
  // USER CODE BEGIN (IO_Function,2)

  // USER CODE END


  ///  -----------------------------------------------------------------------
  ///  Configuration of Port P0:
  ///  -----------------------------------------------------------------------
  ///  P0.7:
  ///  - is used as general purpose output
  ///  - push/pull output is selected
  ///  - the pin status is low level

  P0_OD          =  0x0000;      // load open-drain register
  P0_OUT         =  0x0000;      // load data output register
  P0_PUDSEL      =  0xFFFF;      // load pullup/pulldown select register
  P0_PUDEN       =  0xFFFF;      // load pullup/pulldown enable register
  P0_ALTSEL0     =  0x0000;      // load alternate output function select 
                                 // register 0
  P0_ALTSEL1     =  0x0000;      // load alternate output function select 
                                 // register 1
  P0_DIR         =  0x0080;      // load direction register

  ///  -----------------------------------------------------------------------
  ///  Configuration of Port P1:
  ///  -----------------------------------------------------------------------
  ///  - no pin of port P1 is used

  P1_OD          =  0x0000;      // load open-drain register
  P1_OUT         =  0x0000;      // load data output register
  P1_PUDSEL      =  0xFFFF;      // load pullup/pulldown select register
  P1_PUDEN       =  0xFFFF;      // load pullup/pulldown enable register
  P1_ALTSEL0     =  0x0000;      // load alternate output function select 
                                 // register 0
  P1_ALTSEL1     =  0x0000;      // load alternate output function select 
                                 // register 1
  P1_DIR         =  0x0000;      // load direction register

  ///  -----------------------------------------------------------------------
  ///  Configuration of Port P2:
  ///  -----------------------------------------------------------------------
  ///  P2.1:
  ///  - is used as alternate output for the ASC0 transmit output signal 
  ///    (ASC0_TXD)
  ///  - push/pull output is selected
  ///  P2.2:
  ///  - is used as alternate input for the SSC0 master receive signal 
  ///    (SSC0_MRST)
  ///  - pull-up device is assigned
  ///  P2.3:
  ///  - is used as alternate output for the SSC0 master transmit signal 
  ///    (SSC0_MTSR)
  ///  - push/pull output is selected
  ///  P2.4:
  ///  - is used as alternate output for the SSC0 clock output signal 
  ///    (SSC0_SCLK)
  ///  - push/pull output is selected
  ///  P2.12:
  ///  - is used as alternate output for the SSC0 Slave Select output signal 
  ///    3(SSC0_SLSO)
  ///  - push/pull output is selected

  P2_OD          =  0x0000;      // load open-drain register
  P2_OUT         =  0x0000;      // load data output register
  P2_PUDSEL      =  0xFFFF;      // load pullup/pulldown select register
  P2_PUDEN       =  0xFFFF;      // load pullup/pulldown enable register
  P2_ALTSEL0     =  0x0000;      // load alternate output function select 
                                 // register 0
  P2_ALTSEL1     =  0x0000;      // load alternate output function select 
                                 // register 1
  P2_DIR         =  0x0000;      // load direction register

  ///  -----------------------------------------------------------------------
  ///  Configuration of Port P3:
  ///  -----------------------------------------------------------------------
  ///  - no pin of port P3 is used

  P3_OD          =  0x0000;      // load open-drain register
  P3_OUT         =  0x0000;      // load data output register
  P3_PUDSEL      =  0xFFFF;      // load pullup/pulldown select register
  P3_PUDEN       =  0xFFFF;      // load pullup/pulldown enable register
  P3_ALTSEL0     =  0x0000;      // load alternate output function select 
                                 // register 0
  P3_ALTSEL1     =  0x0000;      // load alternate output function select 
                                 // register 1
  P3_DIR         =  0x0000;      // load direction register

  ///  -----------------------------------------------------------------------
  ///  Configuration of Port P4:
  ///  -----------------------------------------------------------------------
  ///  - no pin of port P4 is used

  P4_OD          =  0x0000;      // load open-drain register
  P4_OUT         =  0x0000;      // load data output register
  P4_PUDSEL      =  0xFFFF;      // load pullup/pulldown select register
  P4_PUDEN       =  0xFFFF;      // load pullup/pulldown enable register
  P4_ALTSEL0     =  0x0000;      // load alternate output function select 
                                 // register 0
  P4_ALTSEL1     =  0x0000;      // load alternate output function select 
                                 // register 1
  P4_DIR         =  0x0000;      // load direction register


  // USER CODE BEGIN (IO_Function,3)

  // USER CODE END

} //  End of function IO_vInit




// USER CODE BEGIN (IO_General,10)

// USER CODE END

