//****************************************************************************
// @ubyte        High-Speed Synchronous Serial Interface (SSC0)
// @Filename      SSC0.h
// @Project       ASC_SSC_IO.dav
//----------------------------------------------------------------------------
// @Controller    Infineon TC1130
//
// @Compiler      Tasking
//
// @Codegenerator 1.4
//
// @Description   This file contains all function prototypes and macros for 
//                the SSC0 module.
//
//----------------------------------------------------------------------------
// @Date          2007-05-09 12:05:39
//
//****************************************************************************

// USER CODE BEGIN (SSC0_Header,1)

// USER CODE END



#ifndef _SSC0_H_
#define _SSC0_H_

//****************************************************************************
// @Project Includes
//****************************************************************************

// USER CODE BEGIN (SSC0_Header,2)

// USER CODE END


//****************************************************************************
// @Macros
//****************************************************************************

// USER CODE BEGIN (SSC0_Header,3)

// USER CODE END


//****************************************************************************
// @Defines
//****************************************************************************

// USER CODE BEGIN (SSC0_Header,4)

#define SD_Disable() SSC0_SSOC=0x00000808;				// SD_ChipSelect auf High (SD Karte inaktiv)

#define SD_Enable()  SSC0_SSOC=0x00000800;				// SD_ChipSelect auf Low (SD Karte aktiv)

// USER CODE END


//****************************************************************************
// @Typedefs
//****************************************************************************

// USER CODE BEGIN (SSC0_Header,5)

// USER CODE END


//****************************************************************************
// @Imported Global Variables
//****************************************************************************

// USER CODE BEGIN (SSC0_Header,6)

// USER CODE END


//****************************************************************************
// @Global Variables
//****************************************************************************

// USER CODE BEGIN (SSC0_Header,7)

// USER CODE END


//****************************************************************************
// @Prototypes Of Global Functions
//****************************************************************************

void SSC0_vInit(void);
void SSC0_vSendData(ubyte usData);
ubyte SSC0_usGetData(void);


// USER CODE BEGIN (SSC0_Header,8)
ubyte SD_Init(void);
void SSC0_vWrite(ubyte *s);
ubyte SSC0_Read(void);
ubyte sd_write_command(ubyte *cmd);
// USER CODE END


//****************************************************************************
// @Macro         SSC0_ubBusy() 
//
//----------------------------------------------------------------------------
// @Description   This macro may be used for checking the status of the busy 
//                flag. When a transfer starts, the busy flag is set. At the 
//                end of a transfer the busy flag is cleared.
//
//----------------------------------------------------------------------------
// @Returnvalue   Returns a 1 if SSC0 is busy, else 0
//
//----------------------------------------------------------------------------
// @Parameters    None
//
//----------------------------------------------------------------------------
// @Date          2007-05-09
//
//****************************************************************************

#define SSC0_ubBusy() SSC0_STAT_BSY


//****************************************************************************
// @Macro         SSC0_vSlaveSelection(ubSlave) 
//
//----------------------------------------------------------------------------
// @Description   This macro enables all slave select output lines selected 
//                by the parameter ubSlave. 
//
//----------------------------------------------------------------------------
// @Returnvalue   None
//
//----------------------------------------------------------------------------
// @Parameters    ubSlave: 
//                Each bit in the parameter enables a slave output. Bit 0 
//                enables output 0 and so on.
//
//----------------------------------------------------------------------------
// @Date          2007-05-09
//
//****************************************************************************

#define SSC0_vSlaveSelection(ubSlave) SSC0_SSOC = (SSC0_SSOC & ~0x0000ff00) | (ubSlave << 8)


//****************************************************************************
// @Interrupt Vectors
//****************************************************************************

#define SSC0TINT    0x08
#define SSC0RINT    0x09

// USER CODE BEGIN (SSC0_Header,9)

// USER CODE END


#endif  // ifndef _SSC0_H_
